"use strict";

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require("react-test-renderer");

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _colorPicker = require("../../color-picker");

var _colorPicker2 = _interopRequireDefault(_colorPicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

test('ColorPicker Base DOM Snapshot', function () {
  var domTree = _reactTestRenderer2.default.create(_react2.default.createElement(_colorPicker2.default, {
    id: "color-picker",
    className: "test_class_name",
    labels: {
      label: 'Choose Color'
    }
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('ColorPicker Menu Open DOM Snapshot', function () {
  var domTree = _reactTestRenderer2.default.create(_react2.default.createElement(_colorPicker2.default, {
    id: "color-picker",
    classNameMenu: "test_class_name_menu",
    isOpen: true,
    labels: {
      label: 'Choose Color'
    }
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('ColorPicker Menu Disabled DOM Snapshot', function () {
  var domTree = _reactTestRenderer2.default.create(_react2.default.createElement(_colorPicker2.default, {
    id: "color-picker",
    disabled: true,
    labels: {
      label: 'Choose Color'
    }
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('ColorPicker Error Text', function () {
  var domTree = _reactTestRenderer2.default.create(_react2.default.createElement(_colorPicker2.default, {
    id: "color-picker",
    errorText: "Outer input in error mode",
    labels: {
      label: 'Choose Color'
    }
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('ColorPicker Custom Variant', function () {
  var domTree = _reactTestRenderer2.default.create(_react2.default.createElement(_colorPicker2.default, {
    id: "color-picker",
    variant: "custom",
    labels: {
      label: 'Choose Color'
    }
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});
test('ColorPicker Swatches Variant', function () {
  var domTree = _reactTestRenderer2.default.create(_react2.default.createElement(_colorPicker2.default, {
    id: "color-picker",
    variant: "swatches",
    labels: {
      label: 'Choose Color'
    }
  })).toJSON();

  expect(domTree).toMatchSnapshot();
});